/* "Magisches Quadrat"- Lsung
*/
public class MagischesQuadrat2 {
	
	// Print Matrix a
	public static void printMatrix (int[][] a) {
		for(int i = 0; i < a.length; i++) {
			for (int j = 0; j < a[0].length; j++) {
				System.out.print (a[i][j] + " ");
			}
			System.out.println();
		}
		System.out.println();
	}
	
	// Check if a is a magic square
	public static boolean isMagicSquare (int[][] a) {
		int i; 
		int j;
		int sum;
		int n = a.length;
		int magicSum = 0;
		
		//--- check diagonals
		for(i = 0; i < n; i++) {
			magicSum = magicSum + a[i][i];
		}
		sum = 0;		
		for(i = 0; i < n; i++) {
			sum = sum + a[i][n-i-1];
		}
		if (sum != magicSum) {
			return false;
		}
		
		//--- check rows
		for(i = 0; i < n; i++) {
			sum = 0;			
			for(j = 0; j < n; j++) {
				sum = sum + a[i][j];
			}
			if (sum != magicSum) {
				return false;
			}
		}
		
		//--- check columns
		for(j = 0; j < n; j++) {
			sum = 0;			
			for(i = 0; i < n; i++){
				sum = sum + a[i][j];
			}
			if (sum != magicSum) {
				return false;
			}
		}
		return true;
	}
	
	public static void main (String[] arg) {		
		int[][] a = {{12,6,15,1},{13,3,10,8},{2,16,5,11},{7,9,4,14}};
		System.out.println ("Eingabe: ");
		printMatrix (a);
		if (isMagicSquare (a))
			System.out.println ("Die Matrix ist ein magisches Quadrat");
		else
			System.out.println ("Die Matrix ist kein magisches Quadrat");
	}
}